#ifndef _ARGUMENT
#define _ARGUMENT

#include "Auxiliar.h"

class Argument{
public:
  /******** files *****/
  string fin;
  string fout;
  string fconf;
  int firstSent,lastSent;
  vector<string> fBilLM; //i-th bil lm
  vector<int> BilFactor; //factor used for i-th bil lm
  vector<float> BilUnk; //incr_unk used for i-th bil lm
  vector<string> fTrgLM; 
  vector<int> TrgFactor;
  vector<float> TrgUnk;
  vector<string> fSrcLM; 
  vector<int> SrcFactor;
  vector<float> SrcUnk;

  vector<string> fsBilLM; 
  vector<int> sBilFactor;
  vector<float> sBilUnk;
  vector<string> fsTrgLM; 
  vector<int> sTrgFactor;
  vector<float> sTrgUnk;
  vector<string> fsSrcLM; 
  vector<int> sSrcFactor;
  vector<float> sSrcUnk;

  vector<string> fsBilXM; 
  vector<int> sBilFactorX;
  vector<string> fsTrgXM; 
  vector<int> sTrgFactorX;
  vector<string> fsSrcXM; 
  vector<int> sSrcFactorX;
  /******** weights *****/
  vector<float> la;
  vector<float> lb;
  vector<float> lt;
  vector<float> ls;
  vector<float> lsb;
  vector<float> lst;
  vector<float> lss;
  vector<float> lxb;
  vector<float> lxt;
  vector<float> lxs;
  float lg,ld,lp0,lp1,lp2;
  float lmc,lsc,ldc,lcc,lfc,lbc;
  float lmp,lsp,ldp,lcp,lfp,lbp;
  /******** other *****/
  bool dropoov,units,verbose,help,ograph;
  int tnb,stacksize,nbest;
  string strategy;
  int nthreads;
  bool zmert;
  /******** files ******/
  ofstream f_out;
  ofstream f_verbose;
  ofstream f_graph;
  ofstream f_nbest;
  ofstream f_units;
  /******** methods *****/
  void read(int argc, char** argv);
  ~Argument(){
    if (f_out.is_open()) f_out.close();
    if (f_verbose.is_open()) f_verbose.close();
    if (f_graph.is_open()) f_graph.close();
    if (f_nbest.is_open()) f_nbest.close();
    if (f_units.is_open()) f_units.close();
  }
  void usage();
};

#endif
