#ifndef _LANGMODS
#define _LANGMODS

#include "Auxiliar.h"

#include "lm/enumerate_vocab.hh"
#include "lm/model.hh"

using namespace std;

class LangModel{
  float incr_unk;
  int index_unk;
  bool isarpa;
  lm::ngram::ModelType     model_type;
  lm::ngram::ProbingModel *hash_probing;
  lm::ngram::TrieModel    *trie_sorted;
  lm::ngram::Model        *arpa;
 public:
  int order;
  LangModel(string,float);
  ~LangModel(){
    if (arpa!=NULL) delete arpa;
    if (hash_probing!=NULL) delete hash_probing;
    if (trie_sorted!=NULL) delete trie_sorted;
  }
  float getCost(vector<string> &);
};

class XModel{
  hash_map<vector<string>,float,hashfvecstring,hasheqvecstring> model;
 public:
  int order;
  XModel(string);
  float getCost(vector<string> &);
};

#endif
